#!/bin/sh

#
# board initializaton for ARM EB01
#
# FLASH: 0x01000000	64KB	Bootcode,Angel
#	 0x01010000	64KB	Application
#	 0x01020000

# RAM: 	 0x02000000 	2MB 	RAM
#	 0x02200000

TOOL_NAME=./armtool.sh
apmc_cgmr=0xffff4020
apmc_sr=0xffff4030
moscs=1
pll_lock=2

echo "configuration of clock generator"
$TOOL_NAME w $apmc_cgmr 0x002F0002
r_d=$($TOOL_NAME r 0xffff4030 1)
echo $moscs
echo $r_d
#while ["$($r_d & $moscs)"!=$moscs]
#do
#r_d=$($TOOL_NAME r 0xffff4030 1)
#done
echo "oscillator is stabilized and switch to 16MHz"
r_d=$($TOOL_NAME r 0xffff4030 1)
echo $r_d
$TOOL_NAME w $apmc_cgmr 0x002F4002
echo "setup PLL"
$TOOL_NAME w $apmc_cgmr 0x032F4102

r_d=$($TOOL_NAME r $apmc_sr 1)
#while [$($r_d & $pll_lock) != $pll_lock]
#do
#r_d=$($TOOL_NAME r $apmc_sr 1)
#done
echo "switch to 32MHz"
$TOOL_NAME w $apmc_cgmr 0x032F8102

echo "initialize board"
# EBI_CSR0
#$TOOL_NAME w 0xffe00000 0x01002529
$TOOL_NAME w 0xffe00000 0x01002121

# EBI_CSR1
$TOOL_NAME w 0xffe00004 0x02002121

# EBI_CSR2 .. EBI_CSR7
$TOOL_NAME w 0xffe00008 0x20000000
$TOOL_NAME w 0xffe0000c 0x30000000
$TOOL_NAME w 0xffe00010 0x40000000
$TOOL_NAME w 0xffe00014 0x50000000
$TOOL_NAME w 0xffe00018 0x60000000
$TOOL_NAME w 0xffe0001c 0x70000000

# REMAP done
$TOOL_NAME w 0xffe00020 1

# 2MByte per CS
$TOOL_NAME w 0xffe00024 6
